#include <wchar.h>
#include "../gdbm-local.h"
#include "../curses.h"
#include "../struktury_dbm.h"
#include "../lib_dbm.h"

void trojky(int kreditu, float vprumer);
int jednicek(int kreditu, float vprumer);
void dvojky(WINDOW * pad, int jednicek, int kreditu, float vprumer);



void hranice25(DBM * dbm_ptr)
{
    struct dbm_info inf;
    WINDOW *pad;
    float vprumer;
    long int i, kreditu;

    inf = zjisti_informace(dbm_ptr);

    vprumer = kreditu = 0;
    for (i = 1; i <= 3; i++) {
	kreditu += inf.kreditu[i];
	vprumer += (float) inf.kreditu[i] * i;
    }

    if ((vprumer / kreditu) < 2.5) {
	trojky(kreditu, vprumer);
	return;
    }
    i = jednicek(kreditu, vprumer);

    pad = newpad(i + 8, 58);

    mvwprintw(pad, 2, 3, "Váš průměr: %f (%i/%i)", vprumer / kreditu,
	      (int) vprumer, kreditu);

    mvwprintw(pad, 4, 3,
	      "Do průměru %f vám chybí %2i kreditů (za 1!)\n\n   ",
	      (float) (vprumer + i) / (kreditu + i), i);

    for (--i; i >= 0; i--) {
	dvojky(pad, i, kreditu, vprumer);
    }

    box(pad, ACS_VLINE, ACS_HLINE);
    wmove(pad, LINES - 1, 0);
    prefresh(pad, 0, 0, 4, 6, LINES - 1, COLS - 1);

    wint_t ch;
    (void) wget_wch(pad, &ch);
    delwin(pad);
}



void trojky(int kreditu, float vprumer)
{
    int trojek = 0;
    WINDOW *new_win;
    wint_t ch;


    new_win = newwin(8, 53, 4, 7);
    box(new_win, ACS_VLINE, ACS_HLINE);

    mvwprintw(new_win, 2, 3, "Váš průměr: %f (%i/%i)",
	      vprumer / kreditu, (int) vprumer, kreditu);

    do {
	trojek++;
	kreditu += 1;
	vprumer += 3.0;
    }
    while (vprumer / kreditu < 2.5);

    mvwprintw(new_win, 4, 3,
	      "Do průměru %f vám chybí %2i kreditů za 3!",
	      (float) (vprumer - 3) / (kreditu - 1), trojek - 1);
    mvwprintw(new_win, 5, 3,
	      "Do průměru %f vám chybí %2i kreditů za 3!",
	      (float) vprumer / kreditu, trojek);
    wrefresh(new_win);
    (void) wget_wch(new_win, &ch);
    delwin(new_win);
    return;
}


int jednicek(int kreditu, float vprumer)
{
    int jedna = 0;

    do {
	jedna++;
	kreditu += 1;
	vprumer += 1.0;
    }
    while (vprumer / kreditu > 2.5);
    return jedna;
}

void dvojky(WINDOW * pad, int jednicek, int kreditu, float vprumer)
{
    int dvojek = 0;

    kreditu += jednicek;
    vprumer += (float) jednicek;

    do {
	dvojek++;
	kreditu += 1;
	vprumer += 2.0;
    }
    while (vprumer / kreditu > 2.5);

    wprintw(pad, "Do průměru %f           %2i (za 1) + %2i (za 2)\n   ",
	    (float) vprumer / kreditu, jednicek, dvojek);

}
