#include <string.h>
#include <memory.h>
#include "zaznam.h"
#include "../gdbm-local.h"
#include "../struktury_dbm.h"
#include "../curses.h"
#include "../lib.h"
#include "../lib_dbm.h"
#include "../struktury.h"

#define HORN 5

void zaznam_editace(DBM * dbm_ptr)
{
    struct zaznam nacteno;
    struct dbm_info informace;
    WINDOW *pad;
    datum klic;
    datum data;
    wint_t klavesa;
    int i;
    int ukazatel, mantinel, zvirazneni;
    wchar_t pom_kod[5];
    wchar_t hl_kod[5];
    wchar_t hl_nazev[40];
    wchar_t hl_nazev_pom[40];


    ukazatel = mantinel = 0;
    zvirazneni = 4;		/* zviraznuje 0 1 2 a 3,
				   na jinou znamku nedela nic */
    wcscpy(hl_kod, L"");
    wcscpy(hl_nazev, L"");

  zacatek:			/* po smazani souboru F8 */

    informace = zjisti_informace(dbm_ptr);

    if (ukazatel >= informace.poc_zaznamu)
	ukazatel = informace.poc_zaznamu - 1;	/* po F8 */

    pad = newpad(informace.poc_zaznamu + 6, COLS);

    erase();

    do {
	clear();
	mvprintw(0, 0,
		 "BACKSPACE nebo F10 = konec;         F8 = smazání zaznamu\n"
		 "Insert = zvýraznění známky;  / = hledání kódu; ? = hledání názvu");
	mvprintw(2, 0, "%i zaznamu.\n", informace.poc_zaznamu);
	mvprintw8(HORN - 1, 0, L"%3s %4s %-40s %5s %5s %6s %6s", "",
		  "kód:", "Název", "sem.", "vsem.", "kredit", "známka");

	i = 0;
	for (klic = dbm_firstkey(dbm_ptr); klic.dptr;
	     klic = dbm_nextkey(dbm_ptr)) {
	    data = dbm_fetch(dbm_ptr, klic);
	    memcpy(&nacteno, data.dptr, data.dsize);

	    wcscpy(hl_nazev_pom, nacteno.nazev);
	    velka_pismena(hl_nazev_pom);

	    if (!wcscmp(nacteno.kod, hl_kod)) {
		attron(COLOR_PAIR(CERVENA));
		mvprintw(2, 15, "Nalezený kód: %2i", i + 1);
		attroff(COLOR_PAIR(CERVENA));
		wattron(pad, COLOR_PAIR(CERVENA));
	    } else if (wcsstr(hl_nazev_pom, hl_nazev) != 0 &&
		       wcscmp(hl_nazev, L"")) {
		wattron(pad, COLOR_PAIR(ZELENA));
	    } else if (zvirazneni == nacteno.znamka) {
		wattron(pad, COLOR_PAIR(FIALOVA));
	    } else {
		wattroff(pad, COLOR_PAIR(ZELENA) | COLOR_PAIR(CERVENA) |
			 COLOR_PAIR(FIALOVA));
	    }

	    if (!nacteno.vsemestru)

		if (!nacteno.vsemestru)
		    wattron(pad, A_BOLD);
	    if (i == ukazatel) {
		wattron(pad, A_REVERSE);
		wcsncpy(pom_kod, nacteno.kod,
			sizeof(pom_kod) / sizeof(pom_kod[0]));
	    }
	    mvwprintw8(pad, i, 0, L"%2i) %4ls %-40ls %5i %5i %6i ", i + 1,
		       nacteno.kod, nacteno.nazev, nacteno.semestr,
		       nacteno.vsemestru, nacteno.kreditu);
	    if (nacteno.znamka)
		wprintw(pad, "%6i", nacteno.znamka);
	    else
		wprintw(pad, "%6s", "");
	    if (i++ == ukazatel)
		wattroff(pad, A_REVERSE);
	    if (!nacteno.vsemestru)
		wattroff(pad, A_BOLD);
	}
	refresh();
	move(LINES - 1, 0);
	prefresh(pad, mantinel, 0, HORN, 0, LINES - 1, COLS - 1);

	(void) get_wch(&klavesa);
	switch (klavesa) {
	case L' ':
	case KEY_DOWN:
	    ukazatel++;
	    if (ukazatel == informace.poc_zaznamu) {
		/*
		   ukazatel = 0;
		   mantinel = 0; / */
		ukazatel--;	//*/
	    }
	    if (ukazatel > (LINES - 1 - HORN) + mantinel)
		mantinel++;
	    break;
	case KEY_UP:
	    ukazatel--;
	    if (ukazatel < 0) {
		/*
		   ukazatel = informace.poc_zaznamu - 1;
		   mantinel = informace.poc_zaznamu - 1 - (LINES - 1 - HORN);
		   / */
		ukazatel++;	//*/
	    }
	    if (ukazatel < mantinel)
		mantinel--;
	    break;
	case '/':
	    echo();
	    move(LINES - 1, 0);
	    addch('/');
	    clrtoeol();
	    getn_wstr((wint_t *) hl_kod,
		      sizeof(hl_kod) / sizeof(hl_kod[0]) - 1);
	    velka_pismena(hl_kod);
	    noecho();
	    break;
	case L'?':
	    echo();
	    move(LINES - 1, 0);
	    addch('?');
	    clrtoeol();
	    getn_wstr((wint_t *) hl_nazev,
		      sizeof(hl_nazev) / sizeof(hl_kod[0]) - 1);
	    velka_pismena(hl_nazev);
	    noecho();
	    break;
	case L'\n':
	    zaznam_prepis(dbm_ptr, pom_kod, HORN + ukazatel - mantinel);
	    break;
	case KEY_F(8):
	    if (informace.poc_zaznamu)
		if (smaz_zaznam(dbm_ptr, ukazatel) == 0) {
		    delwin(pad);
		    goto zacatek;
		}
	    break;
	case KEY_IC:
	    move(LINES - 1, 0);
	    printw("0 1 2 3 ?");
	    clrtoeol();
	    (void) get_wch(&klavesa);
	    switch (klavesa) {
	    case L'0':
		zvirazneni = 0;
		break;
	    case L'1':
		zvirazneni = 1;
		break;
	    case L'2':
		zvirazneni = 2;
		break;
	    case L'3':
		zvirazneni = 3;
		break;
	    default:
		zvirazneni = 4;
		break;
	    }
	    break;
	default:
	    break;
	}
    }
    while (klavesa != KEY_BACKSPACE && klavesa != KEY_F(10));

    delwin(pad);
}
